<template>
  <div class="nav-categories">
    <ul class="group _group">
      <li class="item _title -mobile">
        <div class="name">Категории</div>
        <button
          class="close"
          @click="$emit('close')">Close</button>
      </li>
      <li
        class="item"
        v-for="group in partsCategories"
        :key="group.id + 'g'"
        :class="{ opened : (currentActive.group && group.id === currentActive.group.id) }">
        <flink
          class="name"
          :href="`/categories/${group.slug}`"
          active-class="-active"
          @click.prevent="toggleActive('group', group, null)">
          {{ group.name }}
        </flink>
        <button
          class="name -mobile"
          @click.prevent="toggleActive('group', group, null)">
          {{ group.name }}
        </button>
        <ul
          v-if="group.groupsList.length"
          class="group _subgroup">
          <li
            v-for="subGroup in group.groupsList"
            :key="subGroup.id + 's'"
            class="item"
            :class="{ opened : (currentActive.subgroup && subGroup.id === currentActive.subgroup.id) }">
            <flink
              class="name"
              :href="`/categories/${group.slug}/${subGroup.slug}`"
              active-class="-active"
              @click.prevent="toggleActive('subgroup', group, subGroup)">
              {{ subGroup.name }}
            </flink>
            <button
              class="name -mobile"
              @click.prevent="toggleActive('subgroup', group, subGroup)">
              {{ subGroup.name }}
            </button>
            <ul
              class="group _part"
              v-if="subGroup.groupsList.length">
              <li
                v-for="partName in subGroup.groupsList"
                :key="partName.id + 'p'"
                class="item"
                :class="{ opened : (currentActive.partName && partName.id === currentActive.partName.id) }">
                <flink
                  class="name"
                  active-class="-active"
                  :href="`/categories/${group.slug}/${subGroup.slug}/${partName.slug}`">
                  {{ partName.name }}
                </flink>
              </li>
            </ul>
          </li>
          <li class="group-option">
            <flink
              class="more"
              :href="`/categories/${group.slug}`">
              Все запчасти категории &laquo;{{ group.name }}&raquo;
              <img
                svg-inline
                src="~/assets/svg/arrow/left.svg">
            </flink>
          </li>
        </ul>
      </li>
    </ul>
  </div>
</template>

<script>
export default {
  name: 'PartsCategories',
  props: {
    activeItem: {
      type: Object,
      default() {
        return {
          group: {},
          subgroup: {},
          partName: {},
        };
      },
    },
    partsCategories: {
      type: Array,
      default() { return []; },
    },
  },
  data() {
    return {
      currentActive: {
        group: (this.activeItem && this.activeItem.group) ? this.activeItem.group : {},
        subgroup: (this.activeItem && this.activeItem.subgroup) ? this.activeItem.subgroup : {},
        partName: (this.activeItem && this.activeItem.partName) ? this.activeItem.partName : {},
      },
    };
  },
  methods: {
    toggleActive(level, item, subitem) {
      if (level === 'group' && this.currentActive.group.id === item.id) {
        this.currentActive.group = {};
        this.currentActive.subgroup = {};
        this.$emit('clear-category');
        return false;
      }

      if (subitem && this.currentActive.subgroup.id === subitem.id) {
        this.currentActive.subgroup = {};
        this.$emit('clear-category');
        return false;
      }

      this.currentActive.group = {
        id: item.id,
      };

      if (level === 'subgroup') {
        this.currentActive.subgroup = {
          id: subitem.id,
        };
        this.$emit('selected-category', subitem);
        return true;
      }

      this.$emit('selected-category', item);

      return true;
    },
  },
};
</script>

<style lang="postcss">
  .nav-categories {
    /*TODO: Нужен полный рефакторинг этих стилей*/
    @media screen and (max-width: 980px) {
      display: flex;
      flex-direction: column;
      flex-wrap: nowrap;
      width: 100vw;
      height: 100%;
      flex: 1 0 100%;
      margin: 0;
      background-color: #f4f4f4;

      .group._group,
      .group._subgroup {
        & > .item {
          & > .name {
            display: none;

            &.-mobile {
              display: block;
              border: none;
              border-bottom: 1px solid #c5d1d9;
              text-align: left;
              outline: none;
            }
          }
        }
      }

      & .close {
        display: block;
        font-size: 0;
        width: 3rem;
        position: absolute;
        top: 0;
        bottom: 0;
        right: 0;
        outline: none;
        border: none;
        cursor: pointer;
        background-size: 1rem;
        background-color: transparent;
        background-position: center;
        background-repeat: no-repeat;
        background-image: url("~assets/svg/icon-close-bold.svg");
      }
    }
    @media screen and (min-width: 981px) {
      display: block;
      width: 100%;
      /*  Alex Czech был блинк стилей*/
      .group._group > .item._title.-mobile {
        display: none;
      }
    }

    .group {
      display: block;
      width: 100%;
      margin: 0;
      padding: 0;
      list-style: none;

      @media screen and (max-width: 980px) {
        .item {
          display: block;
          width: 100%;
          &._title {
            display: flex;
            flex-direction: row;
            align-items: center;
            position: relative;
            > .name {
              display: flex!important;
              min-height: 4.5rem;
              font-weight: 700 !important;
            }
            > .name:after {
              content: none;
            }
          }
          > .name {
            position: relative;
            display: flex;
            justify-content: flex-start;
            align-items: center;
            min-height: 3.75rem;
            width: 100%;
            line-height: 1.2;
            color: currentColor;
            cursor: pointer;

            &:after {
              content: "";
              position: absolute;
              top: 0;
              bottom: 0;
              right: 0;
              display: block;
              width: 2.5rem;
              height: 100%;
              background-size: 1rem;
              background-position: center;
              background-repeat: no-repeat;
              background-image: url("~assets/svg/arrow/up-thin.svg");
              transform: rotate(90deg);
              transition: transform 0.2s ease;
            }
          }

          > .group {
            display: none;
          }

          &.opened {
            > .name {
              font-weight: 500;
            }

            > .name:after {
              transform: rotate(180deg);
            }
            > .group {
              display: block;
            }
          }
        }

        &._group {
          > .item > .name {
            padding: 0.25rem 2.5rem 0.25rem 1.5rem;
            font-size: 1.125rem;
            background-color: transparent;

            &:not(:last-child) {
              border-bottom: 1px solid #c5d1d9;
            }

            &:first-child {
              border-top: 1px solid #c5d1d9;
            }
          }
        }
        &._subgroup {
          > .item > .name {
            padding: 0.25rem 2.5rem 0.25rem 2.5rem;
            font-size: 1rem;
            background-color: #ffffff;
          }

          > .item.opened > .name {
            font-weight: 500;
            border-bottom: 1px solid #c5d1d9;
          }
        }
        &._part {
          > .item > .name {
            padding: 0.25rem 1rem 0.25rem 3.5rem;
            font-size: 0.875rem;
            font-weight: 400;
            border-bottom: 1px solid #c5d1d9;
            background-color: #ffffff;
            &:after {
              content: none;
            }
          }

          > .item.opened > .name {
            font-weight: 500;
          }
        }
      }

      @media screen and (min-width: 981px) {
        &._group {
          > .item {
            display: block;
            width: 100%;

            > .name {
              display: block;
              width: 100%;
              padding: 1rem;
              line-height: 1.2;
              font-weight: 400;
              cursor: pointer;
              font-size: 0.875rem;
              color: currentColor;
              background-color: #ededed;

              &:hover {
                background-color: #ffffff;
              }

              &.-active {
                font-weight: 500;
                background-color: #ffffff;
              }

              &.-mobile {
                display: none;
              }

              /*@media screen and (max-width: 1199px) {
                font-size: 0.875rem;
                padding: 0.75rem;
              }*/
            }

            & > .name {
              border: 1px solid #c5d1d9;
            }
            &:not(:last-child) {
              & > .name {
                border-bottom: none;
              }
            }
            &:last-child {
              & > .group._subgroup {
                top: calc(50% - 336px);
              }
            }
          }
        }

        &._subgroup {
          position: absolute;
          top: 0;
          left: 100%;
          padding: 1.875rem 1.875rem 4rem 1.875rem;
          column-count: 3;
          column-gap: 2rem;
          width: calc(100vw - 24rem);
          max-width: 50rem;
          height: auto;
          max-height: 624px;
          background-color: #ffffff;
          border: 1px solid #c5d1d9;
          box-shadow: 0 4px 4px rgba(0, 0, 0, 0.25);
          overflow: hidden;

          > .item {
            display: block;
            > .name {
              display: block;
              width: 100%;
              padding: 0.5rem 0;
              font-size: 0.875rem;
              line-height: 1.2;
              font-weight: 700;
              color: #272727;
              cursor: pointer;

              &:hover {
                color: #4a7db4;
              }

              &.-active {
                color: #4a7db4;
              }

              &.-mobile {
                display: none;
              }
            }
          }
        }

        &._part {
          padding: 0 0 1rem 0;
          > .item {
            display: block;
            > .name {
              display: block;
              width: 100%;
              padding: 0.375rem 0;
              font-size: 0.75rem;
              line-height: 1.2;
              font-weight: 400;
              color: #272727;
              cursor: pointer;

              &:hover {
                color: #4a7db4;
              }

              &.-active {
                color: #4a7db4;
              }
            }
          }
        }

        > .item {
          > .group {
            display: none;
          }

          &:hover {
            .group {
              display: block;
            }

            .name {
              border-right: none;
            }
          }
          &:hover, &:active {
            position: relative;
          }
        }
      }
    }

    .group-option {
      position: absolute;
      bottom: 16px;
      left: 0;
      width: 100%;
      padding-left: 1.875rem;
      padding-right: 1.875rem;

      & > .more {
        display: flex;
        align-items: center;
        justify-content: center;
        height: 30px;
        font-size: 0.75rem;
        color: #1b1b1b;
        border-radius: 50px;
        background-color: #f7f7f7;

        &:hover {
          background-color: #f5f5f5;
        }

        & > svg {
          display: block;
          margin-top: 1px;
          margin-left: 6px;
          width: 4px;
          height: auto;
          fill: #1b1b1b;
          transform: rotate(180deg);
        }
      }
    }

    @media screen and (max-width: 1025px) {
      .group-option {
        position: relative;
        bottom: 0;
        padding-left: 2.5rem;
        padding-right: 2.5rem;
        height: 60px;
        background-color: #fff;

        &:after {
          content: "";
          position: absolute;
          top: 0;
          bottom: 0;
          right: 0;
          display: block;
          width: 2.5rem;
          height: 100%;
          background-size: 1rem;
          background-position: center;
          background-repeat: no-repeat;
          background-image: url("~assets/svg/arrow/up-thin.svg");
          transform: rotate(90deg);
          transition: transform 0.2s ease;
        }

        & > .more {
          justify-content: flex-start;
          height: inherit;
          font-size: 1rem;
          border: none;
          background-color: inherit;

          &:hover {
            background-color: inherit;
          }

          & > svg {
            display: none;
          }
        }
      }
    }
  }
</style>
